package org.dromara.elevator.service;

import org.dromara.elevator.domain.vo.*;
import org.dromara.elevator.domain.bo.EElevatorInfoBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 电梯基础信息;Service接口
 *
 * @author zy
 * @date 2024-08-02
 */
public interface IEElevatorInfoService {

    /**
     * 查询电梯基础信息;
     *
     * @param id 主键
     * @return 电梯基础信息;
     */
    EElevatorInfoVo queryById(Long id);

    /**
     * 分页查询电梯基础信息;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 电梯基础信息;分页列表
     */
    TableDataInfo<EElevatorInfoVo> queryPageList(EElevatorInfoBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的电梯基础信息;列表
     *
     * @param bo 查询条件
     * @return 电梯基础信息;列表
     */
    List<EElevatorInfoVo> queryList(EElevatorInfoBo bo);

    /**
     * 新增电梯基础信息;
     *
     * @param bo 电梯基础信息;
     * @return 是否新增成功
     */
    Boolean insertByBo(EElevatorInfoBo bo);

    /**
     * 修改电梯基础信息;
     *
     * @param bo 电梯基础信息;
     * @return 是否修改成功
     */
    Boolean updateByBo(EElevatorInfoBo bo);

    /**
     * 校验并批量删除电梯基础信息;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据电梯编号查询电梯基础信息;
     *
     * @param code
     * @return 电梯基础信息;
     */
    EElevatorInfoVo selectByElevatorNum(String code);

    /**
     * 根据电梯注册代码查询电梯基础信息;
     *
     * @param registerCode
     * @return 电梯基础信息;
     */
    EElevatorInfoVo selectByRegisterCode(String registerCode);

    /**
     * 根据电梯编号查询电梯基础信息;
     *
     * @param eleNumList 电梯编号列表
     * @return 电梯基础信息
     */
    List<EElevatorInfoVo> selectByElevatorNumList(Collection<String> eleNumList);

    /**
     * 查询电梯品牌统计信息
     *
     * @param bo 查询参数
     * @return 电梯品牌统计
     */
    List<EElevatorBrandStatisticsVo> brandStatisticsChartList(EElevatorInfoBo bo);

    /**
     * 查询电梯使用场景统计信息
     *
     * @param bo 查询参数
     * @return 电梯使用场景统计
     */
    List<EElevatorUseScenarioStatisticsVo> scenarioStatisticsChartList(EElevatorInfoBo bo);

    /**
     * 分页查询电梯状态统计
     *
     * @param bo        查询参数
     * @param pageQuery 分页参数
     * @return 统计信息
     */
    TableDataInfo<EElevatorStateStatisticsVo> queryPageStateStatisticsList(EElevatorInfoBo bo, PageQuery pageQuery);

    /**
     * 电梯综合统计查询
     *
     * @param bo 查询参数
     * @return 电梯综合统计
     */
    EElevatorComprehensiveStatisticsVo comprehensiveStatisticsList(EElevatorInfoBo bo);

    /**
     * 查询电梯实时状态信息
     *
     * @param elevatorNum 电梯编号
     * @return 电梯实时状态信息
     */
    ElevatorRealInfoVo queryElevatorRealInfo(String elevatorNum);

    /**
     * 梯龄统计
     *
     * @param bo 查询参数
     * @return 梯龄统计
     */
    List<EElevatorAgeStatisticsVo> eleAgeStatisticsChartList(EElevatorInfoBo bo);

    /**
     * 获取地图区域信息
     *
     * @param code 地图编号
     * @return 地图区域信息
     */
    String getAreaInfo(String code);

    /**
     * 获取视频监控信息
     *
     * @param elevatorNum 电梯编号
     * @return 视频监控信息
     */
    String getVideoMonitorInfo(String elevatorNum);

    /**
     * 查询记录数
     *
     * @param bo 查询
     * @return 记录数
     */
    Long selectCount(EElevatorInfoBo bo);
}
